-- RTASpeedLimiter
--
-- Version 1.0
-- Autor Ralf08
-- 
-- Change log:
-- 12.04.2015 / Ralf08 / release
-- 12.07.2015 / Ralf08 / small corrections



AttachableSpeedLimiter = {};

local AttachableSpeedLimiter_directory = g_currentModDirectory;

source(Utils.getFilename("RTASpeedLimiter.lua", AttachableSpeedLimiter_directory));

	
function AttachableSpeedLimiter:load()
	self.RTA_A_maxSpeed, self.RTA_new = RTASpeedLimiter:check(self.configFileName)	
end;

function AttachableSpeedLimiter:delete()
end;

function AttachableSpeedLimiter:mouseEvent(posX, posY, isDown, isUp, button)
end;

function AttachableSpeedLimiter:keyEvent(unicode, sym, modifier, isDown)
end;

function AttachableSpeedLimiter:update(dt)
end;

function AttachableSpeedLimiter:updateTick(dt)
end;

function AttachableSpeedLimiter:readStream(streamId, connection)
end;

function AttachableSpeedLimiter:writeStream(streamId, connection)
end;

function AttachableSpeedLimiter:draw()
end;

function AttachableSpeedLimiter:onEnter()
end;

function AttachableSpeedLimiter:onAttach()
	
	local Master = self.attacherVehicle
	local Abb = false
	
	
	-- find drivable
	while Master.RTA_D_maxSpeed == nil do
		Master = Master.attacherVehicle
		if not Master then
			Abb = true
			break;
		end;
	end;
		
	if not Abb then
		local WorkTable = {}
		local slave = nil
		local zzz = nil
		local yyy = nil
		
		zzz = Master.RTA_D_maxSpeed
		
		if self.RTA_new then
			if  Master.RTA_A_new == nil then
				Master.RTA_A_new = {}
			end;
			table.insert(Master.RTA_A_new, self.id)
		end;
		
		if self.RTA_A_maxSpeed then
			zzz = math.min(self.RTA_A_maxSpeed, zzz)
		end;
		
		--set table with search strigs
		table.insert(WorkTable, Master.attachedImplements)
		table.insert(WorkTable, self.attachedImplements)
		while table.getn(WorkTable) > 0 do
			slave = WorkTable[1]
			for i, v in pairs(slave) do
				
				--new vehicle
				if slave[i].object.RTA_new then
					if Master.RTA_A_new == nil then
						Master.RTA_A_new = {}
					end;
					table.insert(Master.RTA_A_new, slave[i].object.id)
				end;
				
				--compare max speed
				yyy = slave[i].object.RTA_A_maxSpeed
				if yyy ~= nil then
					if zzz then
						zzz = math.min(zzz, yyy)
					else
						zzz = yyy
					end;
				end;
				
				--new search string
				if slave[i].object.attachedImplements ~= nil then
					table.insert(WorkTable, slave[i].object.attachedImplements)
				end;
			end;
			table.remove(WorkTable, 1)
		end;
		
		-- set max speed
		if zzz then
			Master.motor.maxForwardSpeed = (zzz +3) / 3.6
		end;
		DrivableSpeedLimiter:onEnter(Master)
	end;
end;

function AttachableSpeedLimiter:onDetach(attacherVehicle)

	local Master = attacherVehicle
	local Abb = false
	
	-- find drivable
	while Master.RTA_D_maxSpeed == nil do
		Master = Master.attacherVehicle
		if not Master then
			Abb = true
			break;
		end;
	end;
	
	if not Abb then
		local WorkTable = {}
		local slave = nil
		local zzz = nil
		local yyy = nil
		
		Master.RTA_A_new = nil
		
		zzz = Master.RTA_D_maxSpeed
		
		--set table with search strig	
		table.insert(WorkTable, Master.attachedImplements)
		while table.getn(WorkTable) > 0 do
			slave = WorkTable[1]
			for i, v in pairs(slave) do
				
				--compare max speed
				--not consider self and children
				if slave[i].object.id ~= self.id then
					
					--new vehicle
					if slave[i].object.RTA_new then
						if not Master.RTA_A_new ~= nil then
							Master.RTA_A_new = {}
						end;
						table.insert(Master.RTA_A_new, slave[i].object.id)
					end;
				
					yyy = slave[i].object.RTA_A_maxSpeed
					if yyy ~= nil then
						if zzz then
							zzz = math.min(zzz, yyy)
						else
							zzz = yyy
						end;
					end;
					
					--new search string
					if slave[i].object.attachedImplements ~= nil then
						table.insert(WorkTable, slave[i].object.attachedImplements)
					end;
				end;
			end;
			table.remove(WorkTable, 1)
		end;
		
		-- set max speed
		if zzz then
			Master.motor.maxForwardSpeed = (zzz +3) / 3.6
		end;
	end;
end;
