-- RTASpeedLimiter
--
-- Version 1.0
-- Autor Ralf08
-- 
-- Change log:
-- 12.04.2015 / Ralf08 / release
-- 12.07.2015 / Ralf08 / small corrections



RTASpeedLimiter = {};

local RTASpeedLimiter_directory = g_currentModDirectory;

function RTASpeedLimiter:check(strName)
	
	local yyy = 0
	local zzz = 0
	local iii = 0
	local speed = nil
	local level = nil
	local name
	local new = nil
	
	if RTA_firstRun == nil then
		RTA_firstRun = false;
		if g_currentMission.missionInfo.savegameDirectory then
			if not fileExists(g_currentMission.missionInfo.savegameDirectory.."/RTASpeedLimiter.xml") then
				local newfile = g_currentMission.missionInfo.savegameDirectory.."/RTASpeedLimiter.xml"
				local xmlFile = createXMLFile("SpeedLimiter",newfile,"data")
				saveXMLFile(xmlFile)
				xmlFile = nil
			end;
			RTA_saved = true
		else
			RTA_saved = false
		end;
	end;
		
	if RTA_saved then
		RTAFile = loadXMLFile("VehicleList", g_currentMission.missionInfo.savegameDirectory.."/RTASpeedLimiter.xml");
					
		-- ID for XML file
		strName = RTASpeedLimiter:name(strName)
	
		-- check vehicle		
		if hasXMLProperty(RTAFile,"data."..strName..".speed") then
			speed = getXMLInt(RTAFile,"data."..strName..".speed");
		else
			new = true
		end;
	
		if speed == 0 then
			speed = nil
		end;
	else
		new = true
	end;
	return speed, new
end;

function RTASpeedLimiter:save(strName, value)
	-- ID for XML file
	strName = RTASpeedLimiter:name(strName)
	
	setXMLInt(RTAFile,"data."..strName..".speed",value);
	saveXMLFile(RTAFile)
end;

function RTASpeedLimiter:name(check)
	check = string.gsub(check, g_modsDirectory, "MOD")
	check = string.gsub(check, "data/vehicles", "DEFAULT")
		
	check = string.sub(check, 1, string.len(check)-4)
	check = string.gsub(check, "/", "_")
	
	return check
end;

function RTASpeedLimiter:saveFile()
	if RTA_saved then
		saveXMLFile(RTAFile)
	else
		local newfile = g_currentMission.missionInfo.savegameDirectory.."/RTASpeedLimiter.xml"
		local xmlFile = createXMLFile("SpeedLimiter",newfile,"data")
		saveXMLFile(xmlFile)
		xmlFile = nil
		RTA_saved = true
	end;
end;

g_careerScreen.saveSavegame = Utils.appendedFunction(g_careerScreen.saveSavegame, RTASpeedLimiter.saveFile);